pragma Warnings (Off);
pragma Ada_95;
pragma Source_File_Name (ada_main, Spec_File_Name => "b~gnatcmd.ads");
pragma Source_File_Name (ada_main, Body_File_Name => "b~gnatcmd.adb");
pragma Suppress (Overflow_Check);
with Ada.Exceptions;

package body ada_main is

   E067 : Short_Integer; pragma Import (Ada, E067, "system__os_lib_E");
   E019 : Short_Integer; pragma Import (Ada, E019, "ada__exceptions_E");
   E015 : Short_Integer; pragma Import (Ada, E015, "system__soft_links_E");
   E013 : Short_Integer; pragma Import (Ada, E013, "system__exception_table_E");
   E047 : Short_Integer; pragma Import (Ada, E047, "ada__assertions_E");
   E038 : Short_Integer; pragma Import (Ada, E038, "ada__containers_E");
   E062 : Short_Integer; pragma Import (Ada, E062, "ada__io_exceptions_E");
   E028 : Short_Integer; pragma Import (Ada, E028, "ada__numerics_E");
   E010 : Short_Integer; pragma Import (Ada, E010, "ada__strings_E");
   E101 : Short_Integer; pragma Import (Ada, E101, "ada__strings__maps_E");
   E104 : Short_Integer; pragma Import (Ada, E104, "ada__strings__maps__constants_E");
   E043 : Short_Integer; pragma Import (Ada, E043, "interfaces__c_E");
   E022 : Short_Integer; pragma Import (Ada, E022, "system__exceptions_E");
   E078 : Short_Integer; pragma Import (Ada, E078, "system__object_reader_E");
   E054 : Short_Integer; pragma Import (Ada, E054, "system__dwarf_lines_E");
   E097 : Short_Integer; pragma Import (Ada, E097, "system__soft_links__initialize_E");
   E037 : Short_Integer; pragma Import (Ada, E037, "system__traceback__symbolic_E");
   E110 : Short_Integer; pragma Import (Ada, E110, "ada__strings__utf_encoding_E");
   E140 : Short_Integer; pragma Import (Ada, E140, "gnat_E");
   E118 : Short_Integer; pragma Import (Ada, E118, "ada__tags_E");
   E108 : Short_Integer; pragma Import (Ada, E108, "ada__strings__text_buffers_E");
   E127 : Short_Integer; pragma Import (Ada, E127, "ada__streams_E");
   E139 : Short_Integer; pragma Import (Ada, E139, "system__file_control_block_E");
   E138 : Short_Integer; pragma Import (Ada, E138, "system__finalization_root_E");
   E136 : Short_Integer; pragma Import (Ada, E136, "ada__finalization_E");
   E135 : Short_Integer; pragma Import (Ada, E135, "system__file_io_E");
   E125 : Short_Integer; pragma Import (Ada, E125, "ada__text_io_E");
   E156 : Short_Integer; pragma Import (Ada, E156, "types_E");
   E143 : Short_Integer; pragma Import (Ada, E143, "gnatvsn_E");
   E152 : Short_Integer; pragma Import (Ada, E152, "hostparm_E");
   E149 : Short_Integer; pragma Import (Ada, E149, "opt_E");
   E162 : Short_Integer; pragma Import (Ada, E162, "output_E");
   E164 : Short_Integer; pragma Import (Ada, E164, "widechar_E");
   E145 : Short_Integer; pragma Import (Ada, E145, "namet_E");
   E173 : Short_Integer; pragma Import (Ada, E173, "fmap_E");
   E171 : Short_Integer; pragma Import (Ada, E171, "osint_E");
   E177 : Short_Integer; pragma Import (Ada, E177, "sdefault_E");
   E179 : Short_Integer; pragma Import (Ada, E179, "targparm_E");
   E182 : Short_Integer; pragma Import (Ada, E182, "switch_E");
   E185 : Short_Integer; pragma Import (Ada, E185, "usage_E");
   E002 : Short_Integer; pragma Import (Ada, E002, "gnatcmd_E");

   Sec_Default_Sized_Stacks : array (1 .. 1) of aliased System.Secondary_Stack.SS_Stack (System.Parameters.Runtime_Default_Sec_Stack_Size);

   Local_Priority_Specific_Dispatching : constant String := "";
   Local_Interrupt_States : constant String := "";

   Is_Elaborated : Boolean := False;

   procedure finalize_library is
   begin
      E125 := E125 - 1;
      declare
         procedure F1;
         pragma Import (Ada, F1, "ada__text_io__finalize_spec");
      begin
         F1;
      end;
      declare
         procedure F2;
         pragma Import (Ada, F2, "system__file_io__finalize_body");
      begin
         E135 := E135 - 1;
         F2;
      end;
      declare
         procedure Reraise_Library_Exception_If_Any;
            pragma Import (Ada, Reraise_Library_Exception_If_Any, "__gnat_reraise_library_exception_if_any");
      begin
         Reraise_Library_Exception_If_Any;
      end;
   end finalize_library;

   procedure adafinal is
      procedure s_stalib_adafinal;
      pragma Import (Ada, s_stalib_adafinal, "system__standard_library__adafinal");

      procedure Runtime_Finalize;
      pragma Import (C, Runtime_Finalize, "__gnat_runtime_finalize");

   begin
      if not Is_Elaborated then
         return;
      end if;
      Is_Elaborated := False;
      Runtime_Finalize;
      s_stalib_adafinal;
   end adafinal;

   type No_Param_Proc is access procedure;
   pragma Favor_Top_Level (No_Param_Proc);

   procedure adainit is
      Main_Priority : Integer;
      pragma Import (C, Main_Priority, "__gl_main_priority");
      Time_Slice_Value : Integer;
      pragma Import (C, Time_Slice_Value, "__gl_time_slice_val");
      WC_Encoding : Character;
      pragma Import (C, WC_Encoding, "__gl_wc_encoding");
      Locking_Policy : Character;
      pragma Import (C, Locking_Policy, "__gl_locking_policy");
      Queuing_Policy : Character;
      pragma Import (C, Queuing_Policy, "__gl_queuing_policy");
      Task_Dispatching_Policy : Character;
      pragma Import (C, Task_Dispatching_Policy, "__gl_task_dispatching_policy");
      Priority_Specific_Dispatching : System.Address;
      pragma Import (C, Priority_Specific_Dispatching, "__gl_priority_specific_dispatching");
      Num_Specific_Dispatching : Integer;
      pragma Import (C, Num_Specific_Dispatching, "__gl_num_specific_dispatching");
      Main_CPU : Integer;
      pragma Import (C, Main_CPU, "__gl_main_cpu");
      Interrupt_States : System.Address;
      pragma Import (C, Interrupt_States, "__gl_interrupt_states");
      Num_Interrupt_States : Integer;
      pragma Import (C, Num_Interrupt_States, "__gl_num_interrupt_states");
      Unreserve_All_Interrupts : Integer;
      pragma Import (C, Unreserve_All_Interrupts, "__gl_unreserve_all_interrupts");
      Detect_Blocking : Integer;
      pragma Import (C, Detect_Blocking, "__gl_detect_blocking");
      Default_Stack_Size : Integer;
      pragma Import (C, Default_Stack_Size, "__gl_default_stack_size");
      Default_Secondary_Stack_Size : System.Parameters.Size_Type;
      pragma Import (C, Default_Secondary_Stack_Size, "__gnat_default_ss_size");
      Bind_Env_Addr : System.Address;
      pragma Import (C, Bind_Env_Addr, "__gl_bind_env_addr");

      procedure Runtime_Initialize (Install_Handler : Integer);
      pragma Import (C, Runtime_Initialize, "__gnat_runtime_initialize");

      Finalize_Library_Objects : No_Param_Proc;
      pragma Import (C, Finalize_Library_Objects, "__gnat_finalize_library_objects");
      Binder_Sec_Stacks_Count : Natural;
      pragma Import (Ada, Binder_Sec_Stacks_Count, "__gnat_binder_ss_count");
      Default_Sized_SS_Pool : System.Address;
      pragma Import (Ada, Default_Sized_SS_Pool, "__gnat_default_ss_pool");

   begin
      if Is_Elaborated then
         return;
      end if;
      Is_Elaborated := True;
      Main_Priority := -1;
      Time_Slice_Value := -1;
      WC_Encoding := 'b';
      Locking_Policy := ' ';
      Queuing_Policy := ' ';
      Task_Dispatching_Policy := ' ';
      Priority_Specific_Dispatching :=
        Local_Priority_Specific_Dispatching'Address;
      Num_Specific_Dispatching := 0;
      Main_CPU := -1;
      Interrupt_States := Local_Interrupt_States'Address;
      Num_Interrupt_States := 0;
      Unreserve_All_Interrupts := 0;
      Detect_Blocking := 0;
      Default_Stack_Size := -1;

      ada_main'Elab_Body;
      Default_Secondary_Stack_Size := System.Parameters.Runtime_Default_Sec_Stack_Size;
      Binder_Sec_Stacks_Count := 1;
      Default_Sized_SS_Pool := Sec_Default_Sized_Stacks'Address;

      Runtime_Initialize (1);

      Finalize_Library_Objects := finalize_library'access;

      Ada.Exceptions'Elab_Spec;
      System.Soft_Links'Elab_Spec;
      System.Exception_Table'Elab_Body;
      E013 := E013 + 1;
      Ada.Assertions'Elab_Spec;
      E047 := E047 + 1;
      Ada.Containers'Elab_Spec;
      E038 := E038 + 1;
      Ada.Io_Exceptions'Elab_Spec;
      E062 := E062 + 1;
      Ada.Numerics'Elab_Spec;
      E028 := E028 + 1;
      Ada.Strings'Elab_Spec;
      E010 := E010 + 1;
      Ada.Strings.Maps'Elab_Spec;
      E101 := E101 + 1;
      Ada.Strings.Maps.Constants'Elab_Spec;
      E104 := E104 + 1;
      Interfaces.C'Elab_Spec;
      System.Exceptions'Elab_Spec;
      E022 := E022 + 1;
      E043 := E043 + 1;
      System.Object_Reader'Elab_Spec;
      E078 := E078 + 1;
      System.Dwarf_Lines'Elab_Spec;
      E054 := E054 + 1;
      System.Os_Lib'Elab_Body;
      E067 := E067 + 1;
      System.Soft_Links.Initialize'Elab_Body;
      E097 := E097 + 1;
      E015 := E015 + 1;
      System.Traceback.Symbolic'Elab_Body;
      E037 := E037 + 1;
      E019 := E019 + 1;
      Ada.Strings.Utf_Encoding'Elab_Spec;
      E110 := E110 + 1;
      Gnat'Elab_Spec;
      E140 := E140 + 1;
      Ada.Tags'Elab_Spec;
      Ada.Tags'Elab_Body;
      E118 := E118 + 1;
      Ada.Strings.Text_Buffers'Elab_Spec;
      E108 := E108 + 1;
      Ada.Streams'Elab_Spec;
      E127 := E127 + 1;
      System.File_Control_Block'Elab_Spec;
      E139 := E139 + 1;
      System.Finalization_Root'Elab_Spec;
      E138 := E138 + 1;
      Ada.Finalization'Elab_Spec;
      E136 := E136 + 1;
      System.File_Io'Elab_Body;
      E135 := E135 + 1;
      Ada.Text_Io'Elab_Spec;
      Ada.Text_Io'Elab_Body;
      E125 := E125 + 1;
      Types'Elab_Spec;
      E156 := E156 + 1;
      E143 := E143 + 1;
      Hostparm'Elab_Spec;
      E152 := E152 + 1;
      Opt'Elab_Spec;
      E149 := E149 + 1;
      Output'Elab_Body;
      E162 := E162 + 1;
      E164 := E164 + 1;
      Namet'Elab_Spec;
      Namet'Elab_Body;
      E145 := E145 + 1;
      Osint'Elab_Spec;
      Fmap'Elab_Body;
      E173 := E173 + 1;
      E177 := E177 + 1;
      E179 := E179 + 1;
      Osint'Elab_Body;
      E171 := E171 + 1;
      E182 := E182 + 1;
      E185 := E185 + 1;
      E002 := E002 + 1;
   end adainit;

   procedure Ada_Main_Program;
   pragma Import (Ada, Ada_Main_Program, "_ada_gnatcmd");

   function main
     (argc : Integer;
      argv : System.Address;
      envp : System.Address)
      return Integer
   is
      procedure Initialize (Addr : System.Address);
      pragma Import (C, Initialize, "__gnat_initialize");

      procedure Finalize;
      pragma Import (C, Finalize, "__gnat_finalize");
      SEH : aliased array (1 .. 2) of Integer;

      Ensure_Reference : aliased System.Address := Ada_Main_Program_Name'Address;
      pragma Volatile (Ensure_Reference);

   begin
      if gnat_argc = 0 then
         gnat_argc := argc;
         gnat_argv := argv;
      end if;
      gnat_envp := envp;

      Initialize (SEH'Address);
      adainit;
      Ada_Main_Program;
      adafinal;
      Finalize;
      return (gnat_exit_status);
   end;

--  BEGIN Object file/option list
   --   ./interfac.o
   --   ./system.o
   --   ./s-stoele.o
   --   ./s-htable.o
   --   ./s-casuti.o
   --   ./s-exctab.o
   --   ./i-c.o
   --   ./s-secsta.o
   --   ./s-stalib.o
   --   ./a-except.o
   --   ./debug.o
   --   ./types.o
   --   ./alloc.o
   --   ./gnatvsn.o
   --   ./hostparm.o
   --   ./csets.o
   --   ./opt.o
   --   ./output.o
   --   ./rident.o
   --   ./table.o
   --   ./widechar.o
   --   ./namet.o
   --   ./fmap.o
   --   ./sdefault.o
   --   ./targparm.o
   --   ./osint.o
   --   ./switch.o
   --   ./usage.o
   --   ./gnatcmd.o
   --   -L./
   --   -L../rts/
   --   -L./
   --   -L/home/abuild/rpmbuild/BUILD/gcc14-14.2.1+git11321-build/gcc-14.2.1+git11321/gcc/ada/
   --   -L/usr/lib/gcc/i586-suse-linux/14/adalib/
   --   -static
   --   -lgnat
   --   -ldl
--  END Object file/option list   

end ada_main;
